<!-- /********************************************************************************
 * Copyright (c) 2020 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 ********************************************************************************/ -->
<div class="input-group mb-3">
  <div class="input-group-prepend">
    <button
      class="btn btn-outline-primary"
      [class.isDisabled]="isDisabled"
      [disabled]="isDisabled"
      [ngbPopover]="calendarContent"
      type="button"
      (click)="showTimePicker = false; markTouched()"
    >
      <em class="fa fa-calendar"></em>
    </button>
  </div>
  <input
    [required]="isRequired"
    disabled
    [value]="dateTimeViewValue"
    class="form-control"
    [ngClass]="isValid ? 'ngrx-forms-valid' : 'ngrx-forms-invalid'"
    [class.isDisabled]="isDisabled"
    type="text"
    placeholder="{{ Globals.DATE_TIME_PLACEHOLDER_PATTERN }}"
  />
  <div class="input-group-append">
    <button
      [class.isDisabled]="isDisabled"
      [disabled]="isDisabled"
      class="btn btn-outline-primary calendar"
      (click)="clearDateTime(); markTouched()"
      type="button"
    >
      <em class="fa fa-times-circle" aria-hidden="true"></em>
    </button>
  </div>
</div>

<ng-template #calendarContent>
  <div>
    <div *ngIf="!showTimePicker">
      <ngb-datepicker
        [dayTemplate]="customDayTemplate"
        name="datePicker"
        [ngModel]="dateTime"
        (dateSelect)="changeDateTime($event); showTimePicker = true"
        [startDate]="dateTime"
      ></ngb-datepicker>
    </div>
    <ng-template #customDayTemplate let-today="today" let-date let-selected="selected">
      <span *ngIf="today; else defaultDayTemplate" class="ngb-dp-day today" [class.bg-primary]="selected">
        {{ date.day }}
      </span>
      <ng-template #defaultDayTemplate let-focused="focused">
        <span class="custom-day" [class.focused]="focused" [class.bg-primary]="selected">
          {{ date.day }}
        </span>
      </ng-template>
    </ng-template>
    <div *ngIf="showTimePicker">
      <button class="btn btn-block btn-outline-secondary" type="button" (click)="showTimePicker = false">
        <em class="fa fa-calendar"></em>
      </button>
      <div class="mt-auto">
        <ngb-timepicker
          name="timePicker"
          [ngModel]="dateTime"
          (ngModelChange)="changeDateTime($event)"
          [seconds]="seconds"
          [hourStep]="hourStep"
          [minuteStep]="minuteStep"
          [secondStep]="secondStep"
        ></ngb-timepicker>
      </div>
    </div>
  </div>
</ng-template>
